<template>
    <div class="custom-file">
        <input id="customFile"
               type="file"
               class="custom-file-input"
               :class="styles"
               @change="processFile($event)"
               :accepts="accepts"
               :disabled="disabled"
               multiple>

        <label class="custom-file-label" for="customFile">Choose file</label>
    </div>
</template>

<script>

    export default {

        data() {

            return {

                lastProcessedFile: null
            }
        },

        props: {

            accepts: { type: String, default: () => '' },
            disabled: { type: Boolean, default: () => false },
            styles: { type: Object, default: () => {}}
        },

        methods: {

            /**
             * Encode file to base64 string.
             *
             * @param file
             * @returns {Promise}
             */
            getBase64(file) {

                return new Promise( (resolve, reject) => {

                    const reader = new FileReader();

                    reader.onload = (e) => resolve(e.target.result);

                    reader.onerror = (error) => reject(error);

                    reader.readAsDataURL(file);
                });
            },


            /**
             * Triggers after files are selected.
             *
             * @param event
             */
            processFile(event) {

                let files = event.target.files;

                Object.keys(files).forEach( async (key) => {

                    // In case if any other component (vee validate) need to fetch uploaded file.
                    this.$emit('change', files[key]);

                    if (! this.accepts.includes(files[key].type.split('/').pop())) {

                        return toastr.error('Invalid file!');
                    }

                    await this.getBase64(files[key])

                        .then( (data) => this.lastProcessedFile = { file: files[key], preview: data })

                        .catch( (errors) => toastr.error('Error processing file!'));
                })
            }
        },

        watch: {

            /**
             * On file change emit event with last processed file.
             *
             * @param newLastProcessedFile
             */
            lastProcessedFile(newLastProcessedFile) {

                this.$emit('fileProcessed', newLastProcessedFile);
            }
        }
    }

</script>